Index: trunk/NEMO/C1D_SRC/step1d.F90
===================================================================
--- trunk/NEMO/C1D_SRC/step1d.F90	(revision 716)
+++ trunk/NEMO/C1D_SRC/step1d.F90	(revision 717)
@@ -154,5 +154,4 @@
          CALL prt_ctl(tab2d_1=qns    , clinfo1=' qns  -   : ', mask1=tmask, ovlap=1)
          CALL prt_ctl(tab2d_1=qsr    , clinfo1=' qsr  -   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab2d_1=runoff , clinfo1=' runoff   : ', mask1=tmask, ovlap=1)
          CALL prt_ctl(tab3d_1=tmask  , clinfo1=' tmask    : ', mask1=tmask, ovlap=1, kdim=jpk)
          CALL prt_ctl(tab3d_1=tn     , clinfo1=' sst  -   : ', mask1=tmask, ovlap=1, kdim=1)
Index: trunk/NEMO/LIM_SRC/ice.F90
===================================================================
--- trunk/NEMO/LIM_SRC/ice.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/ice.F90	(revision 717)
@@ -4,16 +4,10 @@
    !! Sea Ice physics:  diagnostics variables of ice defined in memory
    !!=====================================================================
+   !! History :  2.0  !  03-08  (C. Ethe)  F90: Free form and module
+   !!----------------------------------------------------------------------
 #if defined key_ice_lim
    !!----------------------------------------------------------------------
    !!   'key_ice_lim' :                                   LIM sea-ice model
    !!----------------------------------------------------------------------
-   !! History :
-   !!   2.0  !  03-08  (C. Ethe)  F90: Free form and module
-   !!----------------------------------------------------------------------
-   !!  LIM 2.0, UCL-LOCEAN-IPSL (2005)
-   !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_ice          ! LIM sea-ice parameters
 
@@ -21,103 +15,85 @@
    PRIVATE
 
-   !! * Share Module variables
-   INTEGER , PUBLIC ::   & !!: ** ice-dynamic namelist (namicedyn) **
-      nbiter = 1      ,  &  !: number of sub-time steps for relaxation
-      nbitdr = 250          !: maximum number of iterations for relaxation
+   !!* ice-dynamic namelist (namicedyn) *
+   INTEGER , PUBLIC ::   nbiter = 1         !: number of sub-time steps for relaxation
+   INTEGER , PUBLIC ::   nbitdr = 250       !: maximum number of iterations for relaxation
+   REAL(wp), PUBLIC ::   epsd   = 1.0e-20   !: tolerance parameter for dynamic
+   REAL(wp), PUBLIC ::   alpha  = 0.5       !: coefficient for semi-implicit coriolis
+   REAL(wp), PUBLIC ::   dm     = 0.6e+03   !: diffusion constant for dynamics
+   REAL(wp), PUBLIC ::   om     = 0.5       !: relaxation constant
+   REAL(wp), PUBLIC ::   resl   = 5.0e-05   !: maximum value for the residual of relaxation
+   REAL(wp), PUBLIC ::   cw     = 5.0e-03   !: drag coefficient for oceanic stress
+   REAL(wp), PUBLIC ::   angvg  = 0.e0      !: turning angle for oceanic stress
+   REAL(wp), PUBLIC ::   pstar  = 1.0e+04   !: first bulk-rheology parameter
+   REAL(wp), PUBLIC ::   c_rhg  = 20.e0     !: second bulk-rhelogy parameter
+   REAL(wp), PUBLIC ::   etamn  = 0.e+07    !: minimun value for viscosity
+   REAL(wp), PUBLIC ::   creepl = 2.e-08    !: creep limit
+   REAL(wp), PUBLIC ::   ecc    = 2.e0      !: eccentricity of the elliptical yield curve
+   REAL(wp), PUBLIC ::   ahi0   = 350.e0    !: sea-ice hor. eddy diffusivity coeff. (m2/s)
 
-   REAL(wp), PUBLIC ::   & !!: ** ice-dynamic namelist (namicedyn) **
-      epsd   = 1.0e-20,  &  !: tolerance parameter for dynamic
-      alpha  = 0.5    ,  &  !: coefficient for semi-implicit coriolis
-      dm     = 0.6e+03,  &  !: diffusion constant for dynamics
-      om     = 0.5    ,  &  !: relaxation constant
-      resl   = 5.0e-05,  &  !: maximum value for the residual of relaxation
-      cw     = 5.0e-03,  &  !: drag coefficient for oceanic stress
-      angvg  = 0.e0   ,  &  !: turning angle for oceanic stress
-      pstar  = 1.0e+04,  &  !: first bulk-rheology parameter
-      c_rhg  = 20.e0  ,  &  !: second bulk-rhelogy parameter
-      etamn  = 0.e+07,   &  !: minimun value for viscosity
-      creepl = 2.e-08,   &  !: creep limit
-      ecc    = 2.e0   ,  &  !: eccentricity of the elliptical yield curve
-      ahi0   = 350.e0       !: sea-ice hor. eddy diffusivity coeff. (m2/s)
+   REAL(wp), PUBLIC ::   usecc2             !:  = 1.0 / ( ecc * ecc )
+   REAL(wp), PUBLIC ::   rhoco              !: = rau0 * cw
+   REAL(wp), PUBLIC ::   sangvg, cangvg     !: sin and cos of the turning angle for ocean stress
+   REAL(wp), PUBLIC ::   pstarh             !: pstar / 2.0
 
-   REAL(wp), PUBLIC ::   &  !:
-      usecc2          ,  &  !:  = 1.0 / ( ecc * ecc )
-      rhoco           ,  &  !: = rau0 * cw
-      sangvg, cangvg  ,  &  !: sin and cos of the turning angle for ocean stress
-      pstarh                !: pstar / 2.0
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ahiu , ahiv   !: hor. diffusivity coeff. at ocean U- and V-points (m2/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   pahu , pahv   !: ice hor. eddy diffusivity coef. at ocean U- and V-points
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   hsnm , hicm   !: mean snow and ice thicknesses
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ust2s                 !: friction velocity
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  &  !:
-      u_oce, v_oce,      &  !: surface ocean velocity used in ice dynamics
-      ahiu , ahiv ,      &  !: hor. diffusivity coeff. at ocean U- and V-points (m2/s)
-      pahu , pahv ,      &  !: ice hor. eddy diffusivity coef. at ocean U- and V-points
-      hsnm , hicm ,      &  !: mean snow and ice thicknesses
-      ust2s                 !: friction velocity
+   !!* diagnostic quantities
+!! REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   firic         !: IR flux over the ice (only used for outputs)
+!! REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fcsic         !: Sensible heat flux over the ice (only used for outputs)
+!! REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fleic         !: Latent heat flux over the ice (only used for outputs)
+!! REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qlatic        !: latent flux (only used for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rdvosif       !: Variation of volume at surface (only used for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rdvobif       !: Variation of ice volume at the bottom ice (only used for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fdvolif       !: Total variation of ice volume (only used for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rdvonif       !: Lateral Variation of ice volume (only used for outputs)
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  &  !:
-        sst_ini,         &  !: sst read from a file for ice model initialization 
-        sss_ini             !: sss read from a file for ice model initialization 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sist          !: Sea-Ice Surface Temperature (Kelvin ??? degree ??? I don't know)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tfu           !: Freezing/Melting point temperature of sea water at SSS
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   hicif         !: Ice thickness
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   hsnif         !: Snow thickness
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   hicifp        !: Ice production/melting
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   frld          !: Leads fraction = 1-a/totalarea
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   phicif        !: ice thickness  at previous time 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   pfrld         !: Leads fraction at previous time  
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qstoif        !: Energy stored in the brine pockets
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fbif          !: Heat flux at the ice base
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rdmsnif       !: Variation of snow mass
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rdmicif       !: Variation of ice mass
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qldif         !: heat balance of the lead (or of the open ocean)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qcmif         !: Energy needed to bring the ocean surface layer until its freezing 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fdtcn         !: net downward heat flux from the ice to the ocean
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qdtcn         !: energy from the ice to the ocean point (at a factor 2)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   thcm          !: part of the solar energy used in the lead heat budget
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fstric        !: Solar flux transmitted trough the ice
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ffltbif       !: Array linked with the max heat contained in brine pockets (?)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fscmbq        !: Linked with the solar flux below the ice (?)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   fsbbq         !: Also linked with the solar flux below the ice (?)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   qfvbq         !: Array used to store energy in case of toral lateral ablation (?)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   dmgwi         !: Variation of the mass of snow ice
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
-      firic  ,   &  !: IR flux over the ice (only used for outputs)
-      fcsic  ,   &  !: Sensible heat flux over the ice (only used for outputs)
-      fleic  ,   &  !: Latent heat flux over the ice (only used for outputs)
-      qlatic ,   &  !: latent flux
-      rdvosif,   &  !: Variation of volume at surface (only used for outputs)
-      rdvobif,   &  !: Variation of ice volume at the bottom ice (only used for outputs)
-      fdvolif,   &  !: Total variation of ice volume (only used for outputs)
-      rdvonif,   &  !: Lateral Variation of ice volume (only used for outputs)
-      sist   ,   &  !: Sea-Ice Surface Temperature (Kelvin ??? degree ??? I don't know)
-      tfu    ,   &  !: Melting point temperature of sea water
-      hsnif  ,   &  !: Snow thickness
-      hicif  ,   &  !: Ice thickness
-      hicifp ,   &  !: Ice production/melting
-      frld   ,   &  !: Leads fraction = 1-a/totalarea
-      phicif ,   &  !: ice thickness  at previous time 
-      pfrld  ,   &  !: Leads fraction at previous time  
-      qstoif ,   &  !: Energy stored in the brine pockets
-      fbif   ,   &  !: Heat flux at the ice base
-      rdmsnif,   &  !: Variation of snow mass
-      rdmicif,   &  !: Variation of ice mass
-      qldif  ,   &  !: heat balance of the lead (or of the open ocean)
-      qcmif  ,   &  !: Energy needed to bring the ocean surface layer until its freezing 
-      fdtcn  ,   &  !: net downward heat flux from the ice to the ocean
-      qdtcn  ,   &  !: energy from the ice to the ocean
-      !             !  point (at a factor 2)
-      thcm   ,   &  !: part of the solar energy used in the lead heat budget
-      fstric ,   &  !: Solar flux transmitted trough the ice
-      ffltbif,   &  !: Array linked with the max heat contained in brine pockets (?)
-      fscmbq ,   &  !: Linked with the solar flux below the ice (?)
-      fsbbq  ,   &  !: Also linked with the solar flux below the ice (?)
-      qfvbq  ,   &  !: Array used to store energy in case of toral lateral ablation (?)
-      dmgwi         !: Variation of the mass of snow ice
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   albege        !: Albedo of the snow or ice (only for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   albecn        !: Albedo of the ocean (only for outputs)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   tauc          !: Cloud optical depth
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
-      albege ,   &  !: Albedo of the snow or ice (only for outputs)
-      albecn ,   &  !: Albedo of the ocean (only for outputs)
-      tauc   ,   &  !: Cloud optical depth
-      sdvt          !: u*^2/(Stress/density)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ui_ice, vi_ice   !: two components of the ice   velocity at I-point (m/s)
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ui_oce, vi_oce   !: two components of the ocean velocity at I-point (m/s)
 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpsmax)     ::   scal0   !: ???
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jplayersp1) ::   tbif  !: Temperature inside the ice/snow layer
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
-      u_ice, v_ice,   &  !: two components of the ice velocity (m/s)
-      tio_u, tio_v       !: two components of the ice-ocean stress (N/m2)
+!! REAL(wp), DIMENSION(jpi,jpj,0:jpkmax+1) ::   reslum        !: Relative absorption of solar radiation in each ocean level
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpsmax) ::   &  !:
-      scal0              !: ???
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jplayersp1) ::   &  !:
-      tbif          !: Temperature inside the ice/snow layer
-
-   REAL(wp), DIMENSION(jpi,jpj,0:jpkmax+1) ::    &  !:
-      reslum        !: Relative absorption of solar radiation in each ocean level
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   &  !:
-         sxice, syice, sxxice, syyice, sxyice,      &  !: moments for advection
-         sxsn,  sysn,  sxxsn,  syysn,  sxysn,       &  !:
-         sxa,   sya,   sxxa,   syya,   sxya,        &  !:
-         sxc0,  syc0,  sxxc0,  syyc0,  sxyc0,       &  !:
-         sxc1,  syc1,  sxxc1,  syyc1,  sxyc1,       &  !:
-         sxc2,  syc2,  sxxc2,  syyc2,  sxyc2,       &  !:
-         sxst,  syst,  sxxst,  syyst,  sxyst           !:
+   !!* moment used in the advection scheme
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxice, syice, sxxice, syyice, sxyice   !: for ice  volume
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxsn,  sysn,  sxxsn,  syysn,  sxysn    !: for snow volume
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxa,   sya,   sxxa,   syya,   sxya     !: for ice cover area
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxc0,  syc0,  sxxc0,  syyc0,  sxyc0    !: for heat content of snow
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxc1,  syc1,  sxxc1,  syyc1,  sxyc1    !: for heat content of 1st ice layer
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxc2,  syc2,  sxxc2,  syyc2,  sxyc2    !: for heat content of 2nd ice layer
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sxst,  syst,  sxxst,  syyst,  sxyst    !: for heat content of brine pockets
 
 #else
@@ -127,4 +103,8 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !!  LIM 2.0, UCL-LOCEAN-IPSL (2006)
+   !! $Id$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE ice
Index: trunk/NEMO/LIM_SRC/iceini.F90
===================================================================
--- trunk/NEMO/LIM_SRC/iceini.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/iceini.F90	(revision 717)
@@ -63,11 +63,6 @@
                  
       ! Louvain la Neuve Ice model
-      IF( nacc == 1 ) THEN
-          dtsd2   = nfice * rdtmin * 0.5
-          rdt_ice = nfice * rdtmin
-      ELSE
-          dtsd2   = nfice * rdt * 0.5
-          rdt_ice = nfice * rdt
-      ENDIF
+      dtsd2   = nn_fsbc * rdttra(1) * 0.5
+      rdt_ice = nn_fsbc * rdttra(1)
 
       CALL lim_msh                    ! ice mesh initialization
Index: trunk/NEMO/LIM_SRC/limdia.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limdia.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limdia.F90	(revision 717)
@@ -19,4 +19,5 @@
    USE par_ice         ! ice parameters
    USE ice_oce         ! ice variables
+   USE sbc_oce         ! surface boundary condition variables
    USE daymod          !
    USE dom_ice         !
@@ -87,5 +88,5 @@
 
       nv = 1 
-      vinfor(nv) = REAL( kt + nfice - 1 )
+      vinfor(nv) = REAL( kt + nn_fsbc - 1 )
       nv = nv + 1
       vinfor(nv) = nyear
@@ -107,6 +108,6 @@
                zicevol = zarea   * hicif(ji,jj)
                zsnwvol = zarea   * hsnif(ji,jj)
-               zicespd = zicevol * ( u_ice(ji,jj) * u_ice(ji,jj)   &
-                  &                + v_ice(ji,jj) * v_ice(ji,jj) )
+               zicespd = zicevol * ( ui_ice(ji,jj) * ui_ice(ji,jj)   &
+                  &                + vi_ice(ji,jj) * vi_ice(ji,jj) )
                vinfor(nv+ 1) = vinfor(nv+ 1) + zarea
                vinfor(nv+ 3) = vinfor(nv+ 3) + zextent15
@@ -133,6 +134,6 @@
                 zicevol = zarea   * hicif(ji,jj)
                 zsnwvol = zarea   * hsnif(ji,jj)
-                zicespd = zicevol * ( u_ice(ji,jj) * u_ice(ji,jj)   &
-                   &                + v_ice(ji,jj) * v_ice(ji,jj) )
+                zicespd = zicevol * ( ui_ice(ji,jj) * ui_ice(ji,jj)   &
+                   &                + vi_ice(ji,jj) * vi_ice(ji,jj) )
                 vinfor(nv+ 1) = vinfor(nv+ 1) + zarea
                 vinfor(nv+ 3) = vinfor(nv+ 3) + zextent15
@@ -154,5 +155,5 @@
     
        ! oututs on file ice_evolu    
-       IF( MOD( kt + nfice - 1, ninfo ) == 0 ) THEN
+       IF( MOD( kt + nn_fsbc - 1, ninfo ) == 0 ) THEN
           WRITE(numevo_ice,fmtw) ( titvar(jv), vinfom(jv)/naveg, jv = 1, nvinfo )
           naveg = 0
@@ -227,8 +228,8 @@
 
        ! Definition et Ecriture de l'entete : nombre d'enregistrements 
-       ndeb   = ( nit000 - 1 + nfice - 1 ) / ninfo
-       IF( nit000 - 1 + nfice == 1 ) ndeb = -1
-
-       nferme = ( nitend + nfice - 1 ) / ninfo ! nit000 - 1 + nfice - 1 + nitend - nit000 + 1
+       ndeb   = ( nit000 - 1 + nn_fsbc - 1 ) / ninfo
+       IF( nit000 - 1 + nn_fsbc == 1 ) ndeb = -1
+
+       nferme = ( nitend + nn_fsbc - 1 ) / ninfo ! nit000 - 1 + nn_fsbc - 1 + nitend - nit000 + 1
        ntot   = nferme - ndeb
        ndeb   = ninfo * ( 1 + ndeb )
Index: trunk/NEMO/LIM_SRC/limdyn.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limdyn.F90	(revision 716)
+++ trunk/NEMO/LIM_SRC/limdyn.F90	(revision 717)
@@ -4,4 +4,9 @@
    !!   Sea-Ice dynamics :  
    !!======================================================================
+   !! History :   1.0  !  01-04  (LIM)  Original code
+   !!             2.0  !  02-08  (C. Ethe, G. Madec)  F90, mpp
+   !!             2.0  !  03-08  (C. Ethe) add lim_dyn_init
+   !!             2.0  !  06-07  (G. Madec)  Surface module
+   !!---------------------------------------------------------------------
 #if defined key_ice_lim
    !!----------------------------------------------------------------------
@@ -11,34 +16,31 @@
    !!    lim_dyn_init : initialization and namelist read
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE in_out_manager  ! I/O manager
-   USE dom_ice
-   USE dom_oce         ! ocean space and time domain
-   USE ice
-   USE ice_oce
-   USE iceini
-   USE limistate
-   USE limrhg          ! ice rheology
-   USE lbclnk
-   USE lib_mpp
-   USE prtctl          ! Print control
+   USE dom_oce        ! ocean space and time domain
+   USE sbc_oce        !
+   USE phycst         !
+   USE ice            !
+   USE ice_oce        !
+   USE dom_ice        !
+   USE iceini         !
+   USE limistate      !
+   USE limrhg         ! ice rheology
+
+   USE lbclnk         !
+   USE lib_mpp        !
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC lim_dyn  ! routine called by ice_step
-
-   !! * Module variables
+   PUBLIC   lim_dyn   ! routine called by ice_step
+
    REAL(wp)  ::  rone    = 1.e0   ! constant value
 
-
 #  include "vectopt_loop_substitute.h90"
-
-   !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !!----------------------------------------------------------------------
+   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -57,28 +59,31 @@
       !!              - computation of the stress at the ocean surface         
       !!              - treatment of the case if no ice dynamic
-      !! History :
-      !!   1.0  !  01-04  (LIM)  Original code
-      !!   2.0  !  02-08  (C. Ethe, G. Madec)  F90, mpp
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
-      INTEGER ::   ji, jj             ! dummy loop indices
-      INTEGER ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
-      REAL(wp) ::   &
-         ztairx, ztairy,           &  ! tempory scalars
-         zsang , zrhomod,             &
-         ztglx , ztgly ,           &
-         zt11, zt12, zt21, zt22 ,  &
-         zustm, zsfrld, zsfrldm4,  &
-         zu_ice, zv_ice, ztair2
-      REAL(wp),DIMENSION(jpi,jpj) ::   zmod
-      REAL(wp),DIMENSION(jpj) ::   &
-         zind,                     &  ! i-averaged indicator of sea-ice
-         zmsk                         ! i-averaged of tmask
+      !!
+      INTEGER  ::   ji, jj             ! dummy loop indices
+      INTEGER  ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
+      REAL(wp) ::   zcoef              ! temporary scalar
+      REAL(wp), DIMENSION(jpj)     ::   zind           ! i-averaged indicator of sea-ice
+      REAL(wp), DIMENSION(jpj)     ::   zmsk           ! i-averaged of tmask
+      REAL(wp), DIMENSION(jpi,jpj) ::   zu_io, zv_io   ! ice-ocean velocity
+!!$      INTEGER ::   ji, jj             ! dummy loop indices
+!!$      INTEGER ::   i_j1, i_jpj        ! Starting/ending j-indices for rheology
+!!$      REAL(wp) ::   &
+!!$         ztairx, ztairy,           &  ! tempory scalars
+!!$         zsang , zrhomod,             &
+!!$         ztglx , ztgly ,           &
+!!$         zt11, zt12, zt21, zt22 ,  &
+!!$         zustm, zsfrld, zsfrldm4,  &
+!!$         zu_ice, zv_ice, ztair2
+!!$      REAL(wp),DIMENSION(jpi,jpj) ::   zmod
+!!$      REAL(wp),DIMENSION(jpj) ::   &
+!!$         zind,                     &  ! i-averaged indicator of sea-ice
+!!$         zmsk                         ! i-averaged of tmask
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000  )   CALL lim_dyn_init   ! Initialization (first time-step only)
+      IF( kt == nit000 )   CALL lim_dyn_init   ! Initialization (first time-step only)
       
-      IF ( ln_limdyn ) THEN
+      IF( ln_limdyn ) THEN
 
          ! Mean ice and snow thicknesses.          
@@ -86,7 +91,4 @@
          hicm(:,:)  = ( 1.0 - frld(:,:) ) * hicif(:,:)
 
-         u_io(:,:)  = u_io(:,:) * tmu(:,:)
-         v_io(:,:)  = v_io(:,:) * tmu(:,:)
-       
          !                                         ! Rheology (ice dynamics)
          !                                         ! ========
@@ -98,7 +100,5 @@
             i_j1 = 1   
             i_jpj = jpj
-            IF(ln_ctl)    THEN
-               CALL prt_ctl_info('lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj)
-            ENDIF
+            IF(ln_ctl)   CALL prt_ctl_info( 'lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
             CALL lim_rhg( i_j1, i_jpj )
 
@@ -108,5 +108,4 @@
                zind(jj) = SUM( frld (:,jj  ) )   ! = FLOAT(jpj) if ocean everywhere on a j-line
                zmsk(jj) = SUM( tmask(:,jj,1) )   ! = 0          if land  everywhere on a j-line
-   !!i         write(numout,*) narea, 'limdyn' , jj, zind(jj), zmsk(jj)
             END DO
 
@@ -159,57 +158,62 @@
          ENDIF
 
-         IF(ln_ctl)   THEN 
-            CALL prt_ctl(tab2d_1=u_io , clinfo1=' lim_dyn  : u_io :', tab2d_2=v_io , clinfo2=' v_io :')
-            CALL prt_ctl(tab2d_1=u_ice, clinfo1=' lim_dyn  : u_ice:', tab2d_2=v_ice, clinfo2=' v_ice:')
-         ENDIF
-         
-         !                                         ! Ice-Ocean stress
-         !                                         ! ================        
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-!!              zsang  = SIGN(1.e0, gphif(ji-1,jj-1) ) * sangvg    ! do the full loop and avoid lbc_lnk
-               zsang  = SIGN(1.e0, gphif(ji,jj) ) * sangvg
-               zu_ice   = u_ice(ji,jj) - u_io(ji,jj)
-               zv_ice   = v_ice(ji,jj) - v_io(ji,jj)
-               zrhomod  = zu_ice * zu_ice + zv_ice * zv_ice 
-               zmod (ji,jj) = zrhomod 
-               zrhomod  = rhoco * SQRT( zrhomod ) 
-               ftaux(ji,jj) = zrhomod * ( cangvg * zu_ice - zsang * zv_ice ) 
-               ftauy(ji,jj) = zrhomod * ( cangvg * zv_ice + zsang * zu_ice ) 
+         IF(ln_ctl)   CALL prt_ctl(tab2d_1=ui_ice , clinfo1=' lim_dyn  : ui_ice :', tab2d_2=vi_ice , clinfo2=' vi_ice :')
+         
+!!$         !                                         ! Ice-Ocean stress
+!!$         !                                         ! ================        
+!!$         DO jj = 1, jpj
+!!$            DO ji = 1, jpi
+!!$!!              zsang  = SIGN(1.e0, gphif(ji-1,jj-1) ) * sangvg    ! do the full loop and avoid lbc_lnk
+!!$               zsang  = SIGN(1.e0, gphif(ji,jj) ) * sangvg
+!!$               zu_ice   = u_ice(ji,jj) - u_io(ji,jj)
+!!$               zv_ice   = v_ice(ji,jj) - v_io(ji,jj)
+!!$               zrhomod  = zu_ice * zu_ice + zv_ice * zv_ice 
+!!$               zmod (ji,jj) = zrhomod 
+!!$               zrhomod  = rhoco * SQRT( zrhomod ) 
+!!$               ftaux(ji,jj) = zrhomod * ( cangvg * zu_ice - zsang * zv_ice ) 
+!!$               ftauy(ji,jj) = zrhomod * ( cangvg * zv_ice + zsang * zu_ice ) 
+!!$            END DO
+!!$         END DO
+
+         ! computation of friction velocity
+         ! --------------------------------
+         ! ice-ocean velocity at U & V-points (ui_ice vi_ice at I-point ; ssu_m, ssv_m at U- & V-points)
+         
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zu_io(ji,jj) = 0.5 * ( ui_ice(ji+1,jj+1) + ui_ice(ji+1,jj  ) ) - ssu_m(ji,jj)
+               zv_io(ji,jj) = 0.5 * ( vi_ice(ji+1,jj+1) + vi_ice(ji  ,jj+1) ) - ssv_m(ji,jj)
             END DO
          END DO
-
-         ! computation of friction velocity
+         ! frictional velocity at T-point
          DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1     ! vector opt.
-               ust2s(ji,jj) = 0.25 * cw * ( zmod(ji,jj+1) + zmod(ji+1,jj+1) +    &
-                  &                         zmod(ji,jj  ) + zmod(ji+1,jj  ) ) * tms(ji,jj)
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ust2s(ji,jj) = 0.5 * cw                                                          &
+                  &         * (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
+                  &            + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1)   ) * tms(ji,jj)
             END DO
          END DO
-
-       ELSE      ! no ice dynamics : transmit directly the atmospheric stress to the ocean
-                    
-          ftaux(:,:) = gtaux(:,:) 
-          ftauy(:,:) = gtauy(:,:) 
-
-          DO jj = 2, jpjm1
-             DO ji = 2, jpim1
-                ztair2 = gtaux(ji  ,jj+1) * gtaux(ji  ,jj+1) + gtauy(ji  ,jj+1) * gtauy(ji  ,jj+1)   &
-                &      + gtaux(ji+1,jj+1) * gtaux(ji+1,jj+1) + gtauy(ji+1,jj+1) * gtauy(ji+1,jj+1)   &
-                &      + gtaux(ji  ,jj  ) * gtaux(ji  ,jj  ) + gtauy(ji  ,jj  ) * gtauy(ji  ,jj  )   &
-                &      + gtaux(ji+1,jj  ) * gtaux(ji+1,jj  ) + gtauy(ji+1,jj  ) * gtauy(ji+1,jj  ) 
-
-                ust2s(ji,jj) = 0.25 / rau0 * SQRT( ztair2 ) * tms(ji,jj)
+!!$         DO jj = 2, jpjm1
+!!$            DO ji = fs_2, fs_jpim1     ! vector opt.
+!!$               ust2s(ji,jj) = 0.25 * cw * ( zmod(ji,jj+1) + zmod(ji+1,jj+1) +    &
+!!$                  &                         zmod(ji,jj  ) + zmod(ji+1,jj  ) ) * tms(ji,jj)
+!!$            END DO
+!!$         END DO
+         !
+      ELSE      ! no ice dynamics : transmit directly the atmospheric stress to the ocean
+         !
+         zcoef = SQRT( 0.5 ) / rau0
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ust2s(ji,jj) = zcoef * tms(ji,jj) * SQRT(  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
+                  &                                     + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1) )
             END DO
          END DO
-
+         !
       ENDIF
 
       CALL lbc_lnk( ust2s, 'T',  1. )   ! T-point
 
-      IF(ln_ctl) THEN 
-            CALL prt_ctl(tab2d_1=ftaux , clinfo1=' lim_dyn  : ftaux :', tab2d_2=ftauy , clinfo2=' ftauy :')
-            CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
-      ENDIF
+      IF(ln_ctl)   CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
 
    END SUBROUTINE lim_dyn
@@ -220,14 +224,11 @@
       !!                  ***  ROUTINE lim_dyn_init  ***
       !!
-      !! ** Purpose : Physical constants and parameters linked to the ice
-      !!      dynamics
-      !!
-      !! ** Method  :  Read the namicedyn namelist and check the ice-dynamic
-      !!       parameter values called at the first timestep (nit000)
+      !! ** Purpose :   Physical constants and parameters linked to the ice
+      !!              dynamics
+      !!
+      !! ** Method  :   Read the namicedyn namelist and check the ice-dynamic
+      !!              parameter values
       !!
       !! ** input   :   Namelist namicedyn
-      !!
-      !! history :
-      !!  8.5  ! 03-08 (C. Ethe) original code
       !!-------------------------------------------------------------------
       NAMELIST/namicedyn/ epsd, alpha,     &
@@ -236,11 +237,8 @@
       !!-------------------------------------------------------------------
 
-      ! Define the initial parameters
-      ! -------------------------
-
-      ! Read Namelist namicedyn
-      REWIND ( numnam_ice )
+      REWIND ( numnam_ice )                       ! Read Namelist namicedyn
       READ   ( numnam_ice  , namicedyn )
-      IF(lwp) THEN
+
+      IF(lwp) THEN                                ! Control print
          WRITE(numout,*)
          WRITE(numout,*) 'lim_dyn_init : ice parameters for ice dynamics '
@@ -254,5 +252,5 @@
          WRITE(numout,*) '       maximum value for the residual of relaxation     resl   = ', resl
          WRITE(numout,*) '       drag coefficient for oceanic stress              cw     = ', cw
-         WRITE(numout,*) '       turning angle for oceanic stress                 angvg  = ', angvg
+         WRITE(numout,*) '       turning angle for oceanic stress                 angvg  = ', angvg, ' degrees'
          WRITE(numout,*) '       first bulk-rheology parameter                    pstar  = ', pstar
          WRITE(numout,*) '       second bulk-rhelogy parameter                    c_rhg  = ', c_rhg
@@ -263,17 +261,14 @@
       ENDIF
 
-      !  Initialization
       usecc2 = 1.0 / ( ecc * ecc )
       rhoco  = rau0 * cw
-      angvg  = angvg * rad
+      angvg  = angvg * rad      ! convert angvg from degree to radian
       sangvg = SIN( angvg )
       cangvg = COS( angvg )
       pstarh = pstar / 2.0
-      sdvt(:,:) = 0.e0
-
-      !  Diffusion coefficients.
-      ahiu(:,:) = ahi0 * umask(:,:,1)
+      !
+      ahiu(:,:) = ahi0 * umask(:,:,1)            ! Ice eddy Diffusivity coefficients.
       ahiv(:,:) = ahi0 * vmask(:,:,1)
-
+      !
    END SUBROUTINE lim_dyn_init
 
